module
#include "mcodedef.t.t"
#include "../Gcode/Gcodedef.t.t"
#include "Wuse.t"
#include "mutil.t"
#include "mutil1.t"
#include "mregs.t"
#include "mstrlbl.t"
#include "mstrid.t"
#include "handmade.mcode.t"
#include "machine.t"
export mbasicop;
rec
   commutes add = true
|| commutes mul = true
|| commutes _   = false
and mop3 op a b c & (b = c) = Mop2 op a b
||  mop3 op a b c & (a = c & commutes op) = Mop2 op b a
||  mop3 op a b c = Mop3 op a b c
and
   mbasicop t g G NEG aV S =
	let (a.V) = aV in
	let dr = reg (gdreg aV S) in
	let rec (c, d, u.uv, us, k) = M t g G V1 S
	and    (c1, V1) = 
		if use3op then
			case u in
			  Wpush: (Mop3 sub a (const 0) pushV.c, popV.V)
			||Wuse : (Mop3 sub a (const 0) dr.c, dr.V)
			end
		else
			case u in
			  Wpush: (Mmove (const 0) pushV.
				  Mop2 sub a (Vind 0).c, popV.V)
			||Wuse : (Mmove (const 0) dr.
				  Mop2 sub a dr.c, dr.V)
			end
	in (Mcom "NEG".c1, d, Wuse.uv, us, k)

|| mbasicop t g G op abV S =
	let (a.b.V) = abV in -- must be lazy!
	    if isbinarithop op then
		let op' = mgop op in
		let dr = reg (gdreg V S) in
		let rec (c, d, u.uv, us, k) = M t g G V1 S
		and    (c1, V1) =
		    if use3op then
			case u in
			  Wpush: (Mop3 op' a b pushV.c, popV.V)
			||Wuse : (mop3 op' a b dr.c, dr.V)
			end
		    else
			case u in
			  Wpush: (Mmove b pushV.
				  Mop2 op' a (Vind 0).c, popV.V)
			||Wuse : if b=dr then
					(Mop2 op' a dr.c, dr.V)
				 else if a=dr & commutes op' then
					(Mop2 op' b dr.c, dr.V)
				 else
					-- This is the difficult case. We
					-- must have a temp register that
					-- does not clobber a.
					let dr = reg (gdreg (a.V) S) in
					(Mmove b dr.Mop2 op' a dr.c, dr.V)
			end
		in (Mcom (strop op).c1, d, Wuse.Wuse.uv, us, k)
		
	    else

		let rec (c, d, u.uv, us, k) = M (t+2) g G V1 S
		and    (ar, V1) = 
			case u in
			  Wpush: (pushV, popV.V)
			||Wuse : let r = reg (gdreg V S) in
					(r, r.V)
			end
		in (	
			Mcom (strop op).
			Mcompare a b.
			Mboolcc ((mopcc o ccrev o ccop)op) ar.c,
				d, Wuse.Wuse.uv, us, k)
end
